# PB138 - Film Database Group Project

***

## Name
Film Database

## Description
Filmová databáze obsahuje seznam filmů. Každý film má název, originální název, popisek, režiséra a kategorii. Filmy je možné vyhledat, procházet podle kategorie a nebo se z detailu dostat na filmy režiséra.

Film database containing movies. Each movie has name, original name, description, director and category. Movie search available, browsing categories and getting to director page through detail.

## Stack

Backend technologies:
- NestJS, MeteorJS, ExpressJS, Strapi (Laravel - PHP)

Database technologies (ORM):
- Prisma

Frontend technologies:
- React (+ Ant Design, Mantis), Vue (+ Fast Art, MaterialUI), Svelte

Tools - frameworks:
- NextJS - server side rendering (SSR) for React
- NuxtJS - server side rendering (SSR) for Vue

Tools - libraries:
- Prettier - code formating
- ESLint - static code analysis, validation
- Jest - testing
- yarn, pnpm, turborepo - managing library dependencies

Source compiling:
- Vite, Webpack

Infrastructure:
- dockercompose
	- having all the required services
	- cache - Redis
- relational database
	- Postgres
	- MariaDB
- non/relational database
	- Mongo
	- Redis
	- Minio object storage
- SQLite for testing before deploying

## Usage
### Docker
Firstly, run Docker daemon.

Navigate into the project root directory `pb138-film-database-group-project`.

Then in the root directory run `docker-compose up -d` to build, (re)create, start, and attach to containers for a service (optional flag `-d` runs containers in the background).

When you are finished, run `docker-compose down` to stop and remove containers, networks and images created by `up`.

## TODO

More TBA as features are implemented.
